<?php

/**
 * This Software is the property of Data Development and is protected
 * by copyright law - it is NOT Freeware.
 * Any unauthorized use of this software without a valid license
 * is a violation of the license agreement and will be prosecuted by
 * civil and criminal law.
 * http://www.shopmodule.com
 *
 * @copyright (C) D3 Data Development (Inh. Thomas Dartsch)
 * @link          http://www.oxidmodule.com
 */

/**
 * Class d3_article_variant_mv
 */
class d3_article_variant_mv extends d3_article_variant_mv_parent
{

    public $oArticle;

    /**
     * @return string
     */
    public function render()
    {
        $sRet = parent::render();

        $aTemplateParams = d3_multivariants_application_models_handler::getInstance()->getAdminTemplateParams();
        foreach($aTemplateParams as $sKey => $mValue){
            $this->addTplParam($sKey, $mValue);
        }

        return $sRet;
    }

    /**
     * Lscht alle Varianten dieses Artikels

     */
    public function d3deleteAllVariants()
    {
        d3_multivariants_application_models_handler::getInstance()->deleteAllVariantsFromArticle();
    }

    /**
     *
     */
    public function d3createPictures()
    {
        d3_multivariants_application_models_handler::getInstance()->assignVariantPictures();
    }

    /**
     * TODO: use oxid handling like in article_main
     */
    public function d3copytolang()
    {
        d3_multivariants_application_models_handler::getInstance()->copyVariantsToOtherLang();
    }

    /**
     * Saves all article variants at once.
     *
     * @return null
     */
    public function savevariants()
    {
        $aParams    = oxRegistry::getConfig()->getRequestParameter("editval");
        $sSpacer    = ' ';
        $sSeparator = d3_multivariants_application_models_handler::getInstance()->getSeparator();

        // Aufbereitung der Werte vor dem Speichern, genau ein Leerzeichen wird bentigt
        foreach ($aParams as $sKey => $aValue) {
            $aValues = explode($sSeparator, $aValue['oxarticles__oxvarselect']);
            if (is_array($aValues)) {
                for ($i = 0; $i < count($aValues); $i++) {
                    $aValues[$i] = trim($aValues[$i]);
                }

                $aParams[$sKey]['oxarticles__oxvarselect'] = implode(
                    $sSpacer . $sSeparator . $sSpacer,
                    $aValues
                );
            }
        }

        if (isset($_SERVER['REQUEST_METHOD']) && $_SERVER['REQUEST_METHOD'] == 'POST') {
            $_POST['editval'] = $aParams;
        } elseif (isset($_SERVER['REQUEST_METHOD']) && $_SERVER['REQUEST_METHOD'] == 'GET') {
            $_GET['editval'] = $aParams;
        }

        parent::savevariants();
    }

    /**
     * @return null
     */
    public function changename()
    {
        $aParams    = oxRegistry::getConfig()->getRequestParameter("editval");
        $sSpacer    = ' ';
        $sSeparator = d3_multivariants_application_models_handler::getInstance()->getSeparator();

        // Aufbereitung der Werte vor dem Speichern, genau ein Leerzeichen wird bentigt
        foreach ($aParams as $sKey => $sValue) {
            if (strstr($sKey, 'oxvarname') && strstr($sValue, $sSeparator)) {
                $aValues = explode($sSeparator, $sValue);
                for ($i = 0; $i < count($aValues); $i++) {
                    $aValues[$i] = trim($aValues[$i]);
                }

                $sValue         = implode($sSpacer . $sSeparator . $sSpacer, $aValues);
                $aParams[$sKey] = $sValue;
            }
        }

        if (isset($_SERVER['REQUEST_METHOD']) && $_SERVER['REQUEST_METHOD'] == 'POST') {
            $_POST['editval'] = $aParams;
        } elseif (isset($_SERVER['REQUEST_METHOD']) && $_SERVER['REQUEST_METHOD'] == 'GET') {
            $_GET['editval'] = $aParams;
        }

        parent::changename();
    }

    /**
     * erzeugt aus den gegebenen Moeglichkeiten alle Kombinationen
     *
     * @return NULL
     */
    public function d3createVariantCombination()
    {
        return d3_multivariants_application_models_handler::getInstance()->createVariantCombination();
    }

    /**
     * @param $iKey
     *
     * @return null|string
     */
    public function getLayerTitle($iKey)
    {
        $aLayerTitles = null;
        if ($this->_getArticle()) {
            $sSeparator   = d3_multivariants_application_models_handler::getInstance()->getSeparator();
            $aLayerTitles = explode($sSeparator, $this->_getArticle()->getFieldData('oxvarname'));
        }

        if ($aLayerTitles && is_array($aLayerTitles) && $aLayerTitles[$iKey]) {
            return trim((string)$aLayerTitles[$iKey]);
        } else {
            return null;
        }
    }

    /**
     * @return oxarticle
     */
    protected function _getArticle()
    {
        if (!$this->oArticle) {
            /** @var $oArticle oxarticle */
            $oArticle = oxNew("oxarticle");
            $soxId    = oxRegistry::getConfig()->getRequestParameter("oxid");

            if ($soxId != "-1" && isset($soxId)) {
                $oArticle->loadInLang(oxRegistry::getLang()->getEditLanguage(), $soxId);
            }
            $this->oArticle = $oArticle;
        }

        return $this->oArticle;
    }

    /**
     * @param $sOption
     *
     * @return mixed
     */
    public function getModuleSetting($sOption)
    {
        return d3_multivariants_application_models_handler::getInstance()->getSetting($sOption);
    }
}